#          2022年4月15日 网络 IP 学习笔记

# （一）ip地址的分类及简介

首先我们对IP地址来进行一个基本的简介，对于IP地址来说，它由两部分构成，一是网络号，还有一个是主机号，网络号代表的是因特网上的某一种网络，而主机号代表的无疑就是因特网中的某一台主机了。一般来说，IP地址的长度比较长，达到32位，一共有四个字节，在实际运用中，我们为了方便起见一般用的是点分十进制的方法来进行辨别。

#### IPv4地址一般分为三类：

- **A类地址：10.0.0.0～10.255.255.255**
- **B类地址：172.16.0.0～172.31.255.255**
- **C类地址：192.168.0.0～192.168.255.255**

#### IPv6协议主要定义了三种地址类型：单播地址、组播地址、任播地址。

- 单播地址：用来唯一标识一个接口，类似于IPv4中的单播地址。发送到单播地址的数据报文将被传送给此地址所标识的一个接口。
- 组播地址：用来标识一组接口（通常这组接口属于不同的节点），类似于IPv4中的组播地址。发送到组播地址的数据报文被传送给此地址所标识的所有接口。
- 任播地址：用来标识一组接口（通常这组接口属于不同的节点）。发送到任播地址的数据报文被传送给此地址所标识的一组接口中距离源节点最近（根据使用的路由协议进行度量）的一个接口。

# （二）子网掩码

- 子网掩码(subnet mask)又叫[网络掩码](https://baike.baidu.com/item/网络掩码/7862514)、[地址掩码](https://baike.baidu.com/item/地址掩码/8623995)、子网络遮罩，它用来指明一个[IP地址](https://baike.baidu.com/item/IP地址)的哪些位标识的是[主机](https://baike.baidu.com/item/主机/455151)所在的子网，以及哪些位标识的是主机的位掩码。子网掩码不能单独存在，它必须结合IP地址一起使用。
- 子网掩码是一个32位地址，是与IP地址结合使用的一种技术。它的主要作用有两个，一是用于屏蔽IP地址的一部分以区别网络标识和[主机](https://baike.baidu.com/item/主机)标识，并说明该IP地址是在[局域网](https://baike.baidu.com/item/局域网)上，还是在远程网上。二是用于将一个大的IP网络划分为若干小的子网络。

| 类别 |        子网掩码的二进制数值         | 子网掩码的十进制数值 |
| ---- | :---------------------------------: | -------------------- |
| A    | 11111111 00000000 00000000 00000000 | 255.0.0.0            |
| B    | 11111111 11111111 00000000 00000000 | 255.255.0.0          |
| C    | 11111111 11111111 11111111 00000000 | 255.255.255.0        |

# （三）网关（IP路由器）

- 它相当于我们每个人的身份证号码,每个路由器只能对应一个网关地址。一般的路由背面都有路由本机的IP地址,那个就是你的网关地址。如果你有改过路由的IP,那改后的就是你的地址。