# IP

#### 什么是IP？

如：192.168.1.1、127.0.0.1、75.75.75.75、10.0.1.14、200.0.0.1都属于IP地址。

IP地址中的IP全程为（Internet Protocol）网际互连协议，在IP网络中，通信节点需要唯一标识。

IP地址用于标识通信节点，同时也具有IP报文寻址的功能。

**IP地址通常用点分十进制的形式表示。**

将32比特的二进制码分成四段，每一段将其转换成十进制的数字，中间由点分割，就构成了IP地址。

**IP地址由网络位和主机位构成。**

网络位用于标识主机所属的网络。

主机位用来标识该主机位于网络中的具体位置。如：网络位相当于小区，主机位相当于一号楼

# 子网掩码

#### 如何区分哪一段是网络位，哪一段是主机位？

子网掩码与IP地址搭配使用，子网掩码也是一串32比特的二进制码，和IP地址一一对应，用来描述IP地址中的网络部分及主机部分，子网掩码中为1的位对应IP地址中的网络位，掩码中为0的位对应IP地址中的主机位。

#### IPv4地址主要分五类，分别是A类，B类，C类，D类，E类

| 类别 | 地址范围                  | 网络数   |  主机数  |
| ---- | ------------------------- | -------- | :------: |
| A类  | 0.0.0.0-127.255.255.255   | 128      | 16777216 |
| B类  | 128.0.0.0-191.255.255.255 | 16384    |  65536   |
| C类  | 192.0.0.0-223.255.255.255 | 2097152  |   256    |
| D类  | 224.0.0.0-239.255.255.255 | 组播地址 | 组播地址 |
| E类  | 240.0.0.0-255.255.255.255 | 保留地址 | 保留地址 |

*注：D类和E类是特殊地址，作为保留地址*

#### 公有IP和私有IP：

公有地址：向Inter NIC注册过可以直接访问Internet的地址；

私有地址：未注册过的，专为组织机构内部使用的地址；

| 类别 | 地址                          |
| ---- | ----------------------------- |
| A类  | 10.0.0.0 - 10.255.255.255     |
| B类  | 172.16.0.0 - 172.31.255.255   |
| C类  | 192.168.0.0 - 192.168.255.255 |

#### 如何查看自己的IP地址呢？

直接打开浏览器，在浏览器中输入IP地址或者查询我的IP地址，就可以查看自己的运营商。

如果想查看自己电脑的私有地址：按下Win+R，输入cmd，ipconfig即可。

# 网关

网关：**网关是在网络层以上实现网络互联互通的设备。网关可以让使用不同协议的局域网之间相互通信，或者让不同网络里的设备相互通信**。
网关根据实现的功能可以划分为：**网络应用防火墙，云存储网关，API网关，Ip网关及物联网网关，媒体网关，电子邮件安全网关，IP语音网关**。