# IP地址

**IP地址=网络部分+主机部分=32位**

​              网络部分: 确定终端是不是在一个网段

​              主机部分：确定终端容量的大小（这个网段里最多可容纳多少台)

同一个部门的主机应该要确保在一个网段，主机数量应该在主机容量的范围内

判断主机是否在同一网段的方法

1.把IP地址换算成二进制数
2.把子网掩码换算成二级指数，并且与IP地址对齐
3.把IP地址和子网掩码做“与”（乘法）运算
4.用"有0出0，全1出1"，计算出结果即为网络位/网络号
5.第二个IP的网络号/网络位计算方法同上
6.比较网络位/网络号是否相同。

**子网数，主机容量**
子网数 = 2n( n为网络位借主机位的位数)
主机容量 / 块大小 = 2m(m为主机位数)
有效主机容量 = 2m-2(网络标志位和广播地址不能用于主机的IP地址的编写)
C类有效主机容量 = 28-2 台
B类有效主机容量 = 216-2 台
A类有效主机容量 = 224-2 台

# 子网掩码

​        子网掩码(subnet mask)又叫网络掩码、地址掩码、子网络遮罩，它是一种用来指明一个IP地址的哪些位标识的是主机所在的子网，以及哪些位标识的是主机的位掩码。子网掩码不能单独存在，它必须结合IP地址一起使用。子网掩码只有一个作用，就是将某个IP地址划分成网络地址和主机地址两部分。它是一个32位地址，用于屏蔽IP地址的一部分以区别网络标识和主机标识，并说明该IP地址是在局域网上，还是在广域网上。（例如：IP地址192.168.1.1和255.255.255.0。255.255.255.0就是192.168.1.1的子网掩码。）

**IPV4地址分为5类：A、B、C、D、E**

​               商业用途：A、B、C  ;  组播：D ;科研：E（D类和E类是特殊地址，作为保留地址）

| 类别 | 地址范围                  | 网络数   |  主机数  |
| ---- | ------------------------- | -------- | :------: |
| A类  | 0.0.0.0-127.255.255.255   | 128      | 16777216 |
| B类  | 128.0.0.0-191.255.255.255 | 16384    |  65536   |
| C类  | 192.0.0.0-223.255.255.255 | 2097152  |   256    |
| D类  | 224.0.0.0-239.255.255.255 | 组播地址 | 组播地址 |
| E类  | 240.0.0.0-255.255.255.255 | 保留地址 | 保留地址 |

**默认子网掩码**：是缺省子网掩码即未划分子网，对应的网络号的位都置1，主机号都置0。

**VLSM–变长子网掩码**：变长子网掩码是为了有效的使用无类别域间路由（CIDR）和路由汇聚(route summary)来控制路由表的大小，它是网络管理员常用的IP寻址技术，VLSM就是其中的常用方式，可以对子网进行层次化编址，以便最有效的利用现有的地址空间。

# 网关

**网关**：网关是在网络层以上实现网络互联互通的设备。网关可以让使用不同协议的局域网之间相互通信，或者让不同网络里的设备相互通信。简单来说它就像是快递的中转站，一个区域的网络如果想访问其他用户，就将数据发送到网关，再由网关进行转发。
网关根据实现的功能可以划分为：网络应用防火墙，云存储网关，API网关，Ip网关及物联网网关，媒体网关，电子邮件安全网关，IP语音网关。